Index: extensions/Subscribe_to_comments/include/subscribe_to_comments.inc.php
===================================================================
--- extensions/Subscribe_to_comments/include/subscribe_to_comments.inc.php	(revision 15376)
+++ extensions/Subscribe_to_comments/include/subscribe_to_comments.inc.php	(revision 15641)
@@ -3,5 +3,5 @@
 
 /**
- * detect 'subscriptions' section and load page
+ * detect 'subscriptions' section and load the page
  */
 function stc_detect_section()
@@ -12,4 +12,5 @@
   {
     $page['section'] = 'subscriptions';
+    $page['title'] = l10n('Comments notifications');
   }
 }
@@ -27,5 +28,6 @@
 
 /**
- * send notifications and/or add subscriber
+ * send notifications and/or add subscriber on comment insertion
+ * @param: array comment
  */
 function stc_comment_insertion($comm)
@@ -33,6 +35,4 @@
   global $page, $template;
   
-  $infos = $errors = array();
-  
   if ($comm['action'] == 'validate')
   {
@@ -40,46 +40,58 @@
   }
   
-  if ( !empty($_POST['stc_check']) and ( $comm['action'] == 'validate' or $comm['action'] == 'moderate' ) )
-  {
-    if (isset($comm['image_id']))
-    {
-      $return = subscribe_to_comments($comm['image_id'], @$_POST['stc_mail'], 'image');
-    }
-    else if (isset($comm['category_id']))
-    {
-      $return = subscribe_to_comments($comm['category_id'], @$_POST['stc_mail'], 'category');
-      
-    }
-    
-    if (isset($return))
-    {
-      if ($return === 'confirm_mail')
-      {
-        array_push($infos, l10n('Please check your email inbox to confirm your subscription.'));
-      }
-      else if ($return === true)
-      {
-        array_push($infos, l10n('You have been added to the list of subscribers for this '.(isset($comm['image_id'])?'picture':'album').'.'));
-      }
-      else
-      {
-        array_push($errors, l10n('Invalid email adress, your are not subscribed to comments.'));
-      }
-      
-      // messages management
-      stc_add_messages($errors, $infos, true);
-    }
-  }
-}
-
+  if ( !empty($_POST['stc_mode']) and $_POST['stc_mode'] != -1 )
+  {
+    if ($comm['action'] != 'reject')
+    {
+      if (isset($comm['image_id']))
+      {
+        switch ($_POST['stc_mode'])
+        {
+          case 'all-images':
+            subscribe_to_comments(@$_POST['stc_mail'], 'all-images');
+            break;
+          case 'album-images':
+            if (empty($page['category']['id'])) break;
+            subscribe_to_comments(@$_POST['stc_mail'], 'album-images', $page['category']['id']);
+            break;
+          case 'image':
+            subscribe_to_comments(@$_POST['stc_mail'], 'image', $comm['image_id']);
+            break;
+        }
+      }
+      else if (isset($comm['category_id']))
+      {
+        switch ($_POST['stc_mode'])
+        {
+          case 'all-albums':
+            subscribe_to_comments(@$_POST['stc_mail'], 'all-albums');
+            break;
+          case 'album':
+            subscribe_to_comments(@$_POST['stc_mail'], 'album', $comm['category_id']);
+            break;
+        }
+      }
+    }
+    else
+    {
+      $template->assign('STC_MODE', $_POST['stc_mode']);
+      $template->assign('STC_MAIL', @$_POST['stc_mail']);
+    }
+  }
+}
+
+
+/**
+ * send notifications on comment validation
+ * @param: array|int comment_id
+ * @param: string type (image|category)
+ */
 function stc_comment_validation($comm_ids, $type='image')
 {
   if (!is_array($comm_ids)) $comm_ids = array($comm_ids);
   
-  foreach($comm_ids as $comm_id)
-  {
-    if ($type == 'image')
-    {
-      $query = '
+  if ($type == 'image')
+  {
+    $query = '
 SELECT
     id,
@@ -88,10 +100,10 @@
     content
   FROM '.COMMENTS_TABLE.'
-  WHERE id = '.$comm_id.'
-;';
-    }
-    else if ($type == 'category')
-    {
-      $query = '
+  WHERE id IN('.implode(',', $comm_ids).')
+;';
+  }
+  else if ($type == 'category')
+  {
+    $query = '
 SELECT
     id,
@@ -100,9 +112,11 @@
     content
   FROM '.COA_TABLE.'
-  WHERE id = '.$comm_id.'
-;';
-    }
-    
-    $comm = pwg_db_fetch_assoc(pwg_query($query));
+  WHERE id IN('.implode(',', $comm_ids).')
+;';
+  }
+  
+  $comms = hash_from_query($query, 'id');
+  foreach ($comms as $comm)
+  {
     send_comment_to_subscribers($comm);
   }
@@ -115,73 +129,128 @@
 function stc_on_picture()
 {
-  global $template, $picture, $page, $user;
-  
-  $infos = $errors = array();
-  
+  global $template, $picture, $page, $user, $conf;
+  
+  // standalone subscription
   if (isset($_POST['stc_submit']))
   {
-    $return = subscribe_to_comments($picture['current']['id'], @$_POST['stc_mail_stdl'], 'image');
-    if ($return === 'confirm_mail')
-    {
-      array_push($infos, l10n('Please check your email inbox to confirm your subscription.'));
-    }
-    else if ($return === true)
-    {
-      array_push($infos, l10n('You have been added to the list of subscribers for this picture.'));
-    }
-    else
-    {
-      array_push($errors, l10n('Invalid email adress, your are not subscribed to comments.'));
+    switch ($_POST['stc_mode'])
+    {
+      case 'all-images':
+        subscribe_to_comments(@$_POST['stc_mail'], 'all-images');
+        break;
+      case 'album-images':
+        if (empty($page['category']['id'])) break;
+        subscribe_to_comments(@$_POST['stc_mail'], 'album-images', $page['category']['id']);
+        break;
+      case 'image':
+        subscribe_to_comments(@$_POST['stc_mail'], 'image', $picture['current']['id']);
+        break;
     }
   }
   else if (isset($_GET['stc_unsubscribe']))
-  {
-    if (un_subscribe_to_comments($picture['current']['id'], null, 'image'))
-    {
-      array_push($infos, l10n('Successfully unsubscribed your email address from receiving notifications.'));
-    }
-  }
-  
-  // messages management
-  stc_add_messages($errors, $infos);
+  {    
+    if (un_subscribe_to_comments(null, $_GET['stc_unsubscribe']))
+    {
+      array_push($page['infos'], l10n('Successfully unsubscribed your email address from receiving notifications.'));
+    }
+  }
   
   // if registered user with mail we check if already subscribed
   if ( !is_a_guest() and !empty($user['email']) )
   {
-    $query = '
-SELECT id
-  FROM '.SUBSCRIBE_TO_TABLE.'
-  WHERE
-    email = "'.$user['email'].'"
-    AND image_id = '.$picture['current']['id'].'
-    AND validated = "true"
-;';
-    if (pwg_db_num_rows(pwg_query($query)))
-    {
-      $template->assign(array(
-        'SUBSCRIBED' => true,
-        'UNSUB_LINK' => add_url_params($picture['current']['url'], array('stc_unsubscribe'=>'1')),
-        ));
+    $subscribed = false;
+    
+    // registered to all pictures
+    if (!$subscribed)
+    {
+      $query = '
+SELECT id
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE
+    email = "'.$user['email'].'"
+    AND type = "all-images"
+    AND validated = "true"
+;';
+      $result = pwg_query($query);
+      
+      if (pwg_db_num_rows($result))
+      {
+        $template->assign(array(
+          'SUBSCRIBED_ALL_IMAGES' => true,
+          'MANAGE_LINK' => make_stc_url('manage', $user['email']),
+          ));
+        $subscribed = true;
+      }
+    }
+
+    // registered to pictures in this album
+    if ( !$subscribed and !empty($page['category']['id']) )
+    {
+      $query = '
+SELECT id
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE
+    email = "'.$user['email'].'"
+    AND element_id = '.$page['category']['id'].'
+    AND type = "album-images"
+    AND validated = "true"
+;';
+      $result = pwg_query($query);
+      
+      if (pwg_db_num_rows($result))
+      {
+        list($stc_id) = pwg_db_fetch_row($result);
+        $template->assign(array(
+          'SUBSCRIBED_ALBUM_IMAGES' => true,
+          'UNSUB_LINK' => add_url_params($picture['current']['url'], array('stc_unsubscribe'=>$stc_id)),
+          ));
+        $subscribed = true;
+      }
+    }
+    
+    // registered to this picture
+    if (!$subscribed)
+    {
+      $query = '
+SELECT id
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE
+    email = "'.$user['email'].'"
+    AND element_id = '.$picture['current']['id'].'
+    AND type = "image"
+    AND validated = "true"
+;';
+      $result = pwg_query($query);
+      
+      if (pwg_db_num_rows($result))
+      {
+        list($stc_id) = pwg_db_fetch_row($result);
+        $template->assign(array(
+          'SUBSCRIBED_IMAGE' => true,
+          'UNSUB_LINK' => add_url_params($picture['current']['url'], array('stc_unsubscribe'=>$stc_id)),
+          ));
+        $subscribed = true;
+      }
     }
   }
   else
   {
-    $template->assign('ASK_MAIL', true);
-  }
-  
-  if ( $is_simple = strstr($user['theme'], 'simple') !== false or strstr($user['theme'], 'stripped') !== false )
-    $template->set_prefilter('picture', 'stc_simple_prefilter');
-  else
-    $template->set_prefilter('picture', 'stc_main_prefilter');
-}
-
-/**
- * add field and on album page
+    $template->assign('STC_ASK_MAIL', true);
+  }
+  
+  $template->assign('STC_ON_PICTURE', true);
+  if ( !empty($page['category']['id']) ) $template->assign('STC_ALLOW_ALBUM_IMAGES', true);
+  if ( $conf['Subscribe_to_Comments']['allow_global_subscriptions'] or is_admin() ) $template->assign('STC_ALLOW_GLOBAL', true);
+  
+  $template->set_prefilter('picture', 'stc_main_prefilter');
+}
+
+
+/**
+ * add field and link on album page
  */
 function stc_on_album()
 {
-  global $page, $template, $pwg_loaded_plugins, $user;
-  
-  $infos = $errors = array();
+  global $page, $template, $pwg_loaded_plugins, $user, $conf;
   
   if (
@@ -196,173 +265,110 @@
   if (isset($_POST['stc_submit']))
   {
-    $return = subscribe_to_comments($page['category']['id'], @$_POST['stc_mail_stdl'], 'category');
-    if ($return === 'confirm_mail')
-    {
-      array_push($infos, l10n('Please check your email inbox to confirm your subscription.'));
-    }
-    else if ($return === true)
-    {
-      array_push($infos, l10n('You have been added to the list of subscribers for this album.'));
-    }
-    else
-    {
-      array_push($errors, l10n('Invalid email adress, your are not subscribed to comments.'));
+    switch ($_POST['stc_mode'])
+    {
+      case 'all-albums':
+        subscribe_to_comments(@$_POST['stc_mail'], 'all-albums');
+        break;
+      case 'album':
+        subscribe_to_comments(@$_POST['stc_mail'], 'album', $page['category']['id']);
+        break;
     }
   }
   else if (isset($_GET['stc_unsubscribe']))
   {
-    if (un_subscribe_to_comments($page['category']['id'], null, 'category'))
-    {
-      array_push($infos, l10n('Successfully unsubscribed your email address from receiving notifications.'));
-    }
-  }
-  
-  // messages management
-  stc_add_messages($errors, $infos, true);
+    if (un_subscribe_to_comments(null, $_GET['stc_unsubscribe']))
+    {
+      array_push($page['infos'], l10n('Successfully unsubscribed your email address from receiving notifications.'));
+    }
+  }
   
   // if registered user we check if already subscribed
   if ( !is_a_guest() and !empty($user['email']) )
   {
-    $query = '
-SELECT id
-  FROM '.SUBSCRIBE_TO_TABLE.'
-  WHERE
-    email = "'.$user['email'].'"
-    AND category_id = '.$page['category']['id'].'
-    AND validated = "true"
-;';
-    if (pwg_db_num_rows(pwg_query($query)))
-    {
-      $url_params['section'] = 'categories';
-      $url_params['category'] = $page['category'];
-      $element_url = make_index_url($url_params);
-      
-      $template->assign(array(
-        'SUBSCRIBED' => true,
-        'UNSUB_LINK' => add_url_params($element_url, array('stc_unsubscribe'=>'1')),
-        ));
+    $subscribed = false;
+    
+    // registered to all albums
+    if (!$subscribed)
+    {
+      $query = '
+SELECT id
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE
+    email = "'.$user['email'].'"
+    AND type = "all-albums"
+    AND validated = "true"
+;';
+      $result = pwg_query($query);
+      
+      if (pwg_db_num_rows($result))
+      {
+        $template->assign(array(
+          'SUBSCRIBED_ALL_ALBUMS' => true,
+          'MANAGE_LINK' => make_stc_url('manage', $user['email']),
+          ));
+        $subscribed = true;
+      }
+    }
+    
+    // registered to this album
+    if (!$subscribed)
+    {
+      $query = '
+SELECT id
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE
+    email = "'.$user['email'].'"
+    AND element_id = '.$page['category']['id'].'
+    AND type = "album"
+    AND validated = "true"
+;';
+      $result = pwg_query($query);
+      
+      if (pwg_db_num_rows($result))
+      {
+        list($stc_id) = pwg_db_fetch_row($result);
+        $element_url = make_index_url(array(
+          'section' => 'categories',
+          'category' => $page['category'],
+          ));
+        
+        $template->assign(array(
+          'SUBSCRIBED_ALBUM' => true,
+          'UNSUB_LINK' => add_url_params($element_url, array('stc_unsubscribe'=>$stc_id)),
+          ));
+        $subscribed = true;
+      }
     }
   }
   else
   {
-    $template->assign('ASK_MAIL', true);
-  }
-  
-  if ( $is_simple = strstr($user['theme'], 'simple') !== false or strstr($user['theme'], 'stripped') !== false )
-    $template->set_prefilter('comments_on_albums', 'stc_simple_prefilter');
-  else
-    $template->set_prefilter('comments_on_albums', 'stc_main_prefilter');
-}
-
-
-/**
- * prefilter for common themes
+    $template->assign('STC_ASK_MAIL', true);
+  }
+  
+  $template->assign('STC_ON_ALBUM', true);
+  if ( $conf['Subscribe_to_Comments']['allow_global_subscriptions'] or is_admin() ) $template->assign('STC_ALLOW_GLOBAL', true);
+
+  $template->set_prefilter('comments_on_albums', 'stc_main_prefilter');
+}
+
+
+/**
+ * main prefilter
  */
 function stc_main_prefilter($content, &$smarty)
-{  
+{
   ## subscribe at any moment ##
-  $search = '#\<\/div\>(.{0,10})\{\/if\}(.{0,10})\{\*comments\*\}#is';
-  
-  $replace = '
-<form method="post" action="{$comment_add.F_ACTION}" class="filter" id="stc_standalone">
-  <fieldset>
-  {if $SUBSCRIBED}
-    {\'You are currently subscribed to comments of this picture.\'|@translate}
-    <a href="{$UNSUB_LINK}">{\'Unsubscribe\'|@translate}
-  {else}
-    <legend>{\'Subscribe without commenting\'|@translate}</legend>
-    {if $ASK_MAIL}
-      <label>{\'Email address\'|@translate} <input type="text" name="stc_mail_stdl"></label>
-      <label><input type="submit" name="stc_submit" value="{\'Submit\'|@translate}"></label>
-    {else}
-      <label><input type="submit" name="stc_submit" value="{\'Subscribe\'|@translate}"></label>
-    {/if}
-  {/if}
-  </fieldset>
-</form>
-</div>$1{/if}$2{*comments*}';
-
-  $content = preg_replace($search, $replace, $content);
+  $search = '{if isset($comments)}';
+  $replace = file_get_contents(SUBSCRIBE_TO_PATH.'template/form_standalone.tpl');
+  $content = str_replace($search, $replace.$search, $content);
   
   ## subscribe while add a comment ##
-  $search = '#<input type="hidden" name="key" value="{\$comment_add\.KEY}"([ /]*)>#';
-  
-  $replace = '
-<input type="hidden" name="key" value="{$comment_add.KEY}"$1>
-{if !$SUBSCRIBED}
-  <label>{\'Notify me of followup comments\'|@translate} <input type="checkbox" name="stc_check" value="1"></label><br>
-
-  {if $ASK_MAIL}
-    <label id="stc_mail" style="display:none;">{\'Email address\'|@translate} <input type="text" name="stc_mail"></label><br>
-    {footer_script require="jquery"}{literal}
-    jQuery(document).ready(function() {
-      $("input[name=stc_check]").change(function() {
-        if ($(this).is(":checked")) $("#stc_mail").css("display", "");
-        else $("#stc_mail").css("display", "none");
-      });
-    });
-    {/literal}{/footer_script}
-  {/if}
-{/if}';
-  
-  $content = preg_replace($search, $replace, $content);
+  $search = '<p><textarea name="content" id="contentid" rows="5" cols="50">{$comment_add.CONTENT}</textarea></p>';
+  $replace = file_get_contents(SUBSCRIBE_TO_PATH.'template/form_comment.tpl');
+  $content = str_replace($search, $search.$replace, $content);
   
   return $content;
 }
 
-/**
- * prefilter for simple/stripped themes
- */
-function stc_simple_prefilter($content, &$smarty)
-{  
-  ## subscribe at any moment ##
-  $search = '#\<\/div\>(.{0,10})\{\/if\}(.{0,10})\{if \!empty\(\$navbar\) \}\{include file\=\'navigation_bar.tpl\'\|\@get_extent:\'navbar\'\}\{\/if\}#is';
-  
-  $replace = '
-<form method="post" action="{$comment_add.F_ACTION}" class="filter" id="stc_standalone">
-  <fieldset>
-  {if $SUBSCRIBED}
-    {\'You are currently subscribed to comments of this album.\'|@translate}
-    <a href="{$UNSUB_LINK}">{\'Unsubscribe\'|@translate}
-  {else}
-    <legend>{\'Subscribe without commenting\'|@translate}</legend>
-    {if $ASK_MAIL}
-      <label>{\'Email address\'|@translate} <input type="text" name="stc_mail_stdl"></label>
-      <label><input type="submit" name="stc_submit" value="{\'Submit\'|@translate}"></label>
-    {else}
-      <label><input type="submit" name="stc_submit" value="{\'Subscribe\'|@translate}"></label>
-    {/if}
-  {/if}
-  </fieldset>
-</form>
-</div>$1{/if}$2{if !empty($navbar) }{include file=\'navigation_bar.tpl\'|@get_extent:\'navbar\'}{/if}';
-
-  $content = preg_replace($search, $replace, $content);
-  
-  ## subscribe while add a comment ##
-  $search = '#<input type="hidden" name="key" value="{\$comment_add\.KEY}"([ /]*)>#';
-  
-  $replace = '
-<input type="hidden" name="key" value="{$comment_add.KEY}"$1>
-{if !$SUBSCRIBED}
-  <label>{\'Notify me of followup comments\'|@translate} <input type="checkbox" name="stc_check" value="1"></label><br>
-
-  {if $ASK_MAIL}
-    <label id="stc_mail" style="display:none;">{\'Email address\'|@translate} <input type="text" name="stc_mail"></label><br>
-    {footer_script require="jquery"}{literal}
-    jQuery(document).ready(function() {
-      $("input[name=stc_check]").change(function() {
-        if ($(this).is(":checked")) $("#stc_mail").css("display", "");
-        else $("#stc_mail").css("display", "none");
-      });
-    });
-    {/literal}{/footer_script}
-  {/if}
-{/if}';
-  
-  $content = preg_replace($search, $replace, $content);
-  
-  return $content;
-}
 
 /**
@@ -375,39 +381,15 @@
   if (!empty($user['email']))
   {
+    $template->assign('MANAGE_LINK', make_stc_url('manage', $user['email']) );
     $template->set_prefilter('profile_content', 'stc_profile_link_prefilter');
   }
 }
-
 function stc_profile_link_prefilter($content, &$smarty)
 {
-  global $user;
-  
   $search = '<p class="bottomButtons">';
-  $replace = '<a href="'.make_stc_url('manage', $user['email']).'" title="{\'Manage my subscriptions to comments\'|@translate}" rel="nofollow">{\'Manage my subscriptions to comments\'|@translate}</a><br>';
-  
-  return str_replace($search, $search.$replace, $content);
-}
-
-/**
- * must overload messages because Piwigo is weird
- */
-function stc_add_messages($errors, $infos, $prefilter=false)
-{
-  global $template;
-  
-  if (!empty($errors))
-  {
-    $errors_bak = $template->get_template_vars('errors');
-    if (empty($errors_bak)) $errors_bak = array();
-    $template->assign('errors', array_merge($errors_bak, $errors));
-    if ($prefilter) $template->set_prefilter('index', 'coa_messages'); // here we use a prefilter existing in COA
-  }
-  if (!empty($infos))
-  {
-    $infos_bak = $template->get_template_vars('infos');
-    if (empty($infos_bak)) $infos_bak = array();
-    $template->assign('infos', array_merge($infos_bak, $infos));
-    if ($prefilter) $template->set_prefilter('index', 'coa_messages');
-  }
-}
+  $replace = '<p style="font-size:1.1em;text-decoration:underline;"><a href="{$MANAGE_LINK}" rel="nofollow">{\'Manage my subscriptions to comments\'|@translate}</a></p>';
+  
+  return str_replace($search, $replace.$search, $content);
+}
+
 ?>
Index: extensions/Subscribe_to_comments/include/subscribtions_page.inc.php
===================================================================
--- extensions/Subscribe_to_comments/include/subscribtions_page.inc.php	(revision 15376)
+++ extensions/Subscribe_to_comments/include/subscribtions_page.inc.php	(revision 15641)
@@ -2,10 +2,9 @@
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-global $template, $conf;
-
-$infos = $errors = array();
+global $template, $conf, $page, $pwg_loaded_plugins;
 
 // check input parameters
 $_GET['verif_key'] = $_GET['action'].$_GET['email'].(isset($_GET['id'])?$_GET['id']:null);
+
 if ( 
   empty($_GET['action']) or empty($_GET['email']) or empty($_GET['key'])
@@ -13,43 +12,58 @@
   )
 {
-  $_GET['action'] = 'hacker';
+  $_GET['action'] = null;
 }
 else
 {
-  // sanitize inputs
-  if (isset($_GET['id'])) $_GET['id'] = pwg_db_real_escape_string($_GET['id']);
-  $_GET['email'] = pwg_db_real_escape_string($_GET['email']);
-
-  // unsubscribe
-  if (isset($_POST['unsubscribe']))
-  {
-    if (un_subscribe_to_comments(!empty($_GET['id'])?$_GET['id']:'N/A', $_GET['email'], $_POST['unsubscribe']))
-    {
-      array_push($infos, l10n('Successfully unsubscribed your email address from receiving notifications.'));
-    }
-    else
-    {
-      array_push($errors, l10n('Invalid email adress.'));
-    }
-    
-    $_GET['action'] = 'manage';
-  }
+  // unsubscribe all
+  if ( isset($_POST['unsubscribe_all']) and isset($_POST['unsubscribe_all_check']) )
+  {
+    $query = '
+DELETE FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE email = "'.$_GET['email'].'"
+;';
+    pwg_query($query);
+  }
+  
+  // bulk action
+  if (isset($_POST['apply_bulk']))
+  {
+    foreach ($_POST['selected'] as $id)
+    {
+      switch ($_POST['action'])
+      {
+        case 'unsubscribe':
+          un_subscribe_to_comments($_GET['email'], $id);
+          break;
+        case 'validate':
+          validate_subscriptions($_GET['email'], $id);
+          break;
+      }
+    }
+  }
+  
+  // unsubscribe from manage page
   if (isset($_GET['unsubscribe']))
   {
-    $query = '
-  DELETE FROM '.SUBSCRIBE_TO_TABLE.'
-    WHERE 
-      id = '.pwg_db_real_escape_string($_GET['unsubscribe']).'
-      AND email = "'.$_GET['email'].'"
-  ;';
-    pwg_query($query);
-    
-    if (pwg_db_changes(null) != 0)
-    {
-      array_push($infos, l10n('Successfully unsubscribed your email address from receiving notifications.'));
-    }
-    else
-    {
-      array_push($errors, l10n('Invalid email adress.'));
+    if (un_subscribe_to_comments($_GET['email'], $_GET['unsubscribe']))
+    {
+      array_push($page['infos'], l10n('Successfully unsubscribed your email address from receiving notifications.'));
+    }
+    else
+    {
+     array_push($page['errors'], l10n('Not found.'));
+    }
+  }
+  
+  // validate from manage page
+  if (isset($_GET['validate']))
+  {
+    if (validate_subscriptions($_GET['email'], $_GET['validate']))
+    {
+      array_push($page['infos'], l10n('Your subscribtion has been validated, thanks you.'));
+    }
+    else
+    {
+      array_push($page['infos'], l10n('Already validated.'));
     }
   }
@@ -58,99 +72,147 @@
 }
 
+
 switch ($_GET['action'])
 {
   /* validate */
-  case 'validate-image' :
-  {
-    if (validate_subscriptions($_GET['id'], $_GET['email'], 'image'))
-    {
-      array_push($infos, l10n('Your subscribtion has been validated, thanks you.'));
-    }
-    else
-    {
-      array_push($errors, l10n('Nothing to validate.'));
-    }
-    
-    $element = get_picture_infos($_GET['id']);
-    
-    $template->assign(array(
-      'validate' => 'image',
-      'element' => $element,
-      ));
-      
-    break;
-  }
-  case 'validate-category':
-  {
-    if (validate_subscriptions($_GET['id'], $_GET['email'], 'category'))
-    {
-      array_push($infos, l10n('Your subscribtion has been validated, thanks you.'));
-    }
-    else
-    {
-      array_push($errors, l10n('Nothing to validate.'));
-    }
-    
-    $element = get_category_infos($_GET['id']);
-    
-    $template->assign(array(
-      'validate' => 'category',
-      'element' => $element,
-      ));
-    break;
-  }
-  
-  /* unsubscribe */
-  case 'unsubscribe-image' :
-  {  
-    $element = get_picture_infos($_GET['id']);
-    
-    $template->assign(array(
-      'unsubscribe_form' => 'image',
-      'element' => $element,
-      ));
-    
-    break;
-  }
-  case 'unsubscribe-category':
-  {  
-    $element = get_category_infos($_GET['id']);
-    
-    $template->assign(array(
-      'unsubscribe_form' => 'category',
-      'element' => $element,
-      ));
-    
-    break;
-  }
-  
-  /* manage */
-  case 'manage' :
-  {
-    $query = '
-SELECT *
+  case 'validate':
+  {
+    $query = '
+SELECT
+    type,
+    element_id
   FROM '.SUBSCRIBE_TO_TABLE.'
   WHERE 
     email = "'.$_GET['email'].'"
-    AND validated = "true"
+    AND id = '.$_GET['id'].'
+;';
+    $result = pwg_query($query);
+    
+    if (!pwg_db_num_rows($result))
+    {
+      array_push($page['errors'], l10n('Not found.'));
+    }
+    else
+    {
+      if (validate_subscriptions($_GET['email'], $_GET['id']))
+      {
+        array_push($page['infos'], l10n('Your subscribtion has been validated, thanks you.'));
+      }
+      else
+      {
+        array_push($page['infos'], l10n('Already validated.'));
+      }
+      
+      list($type, $element_id) = pwg_db_fetch_row($result);
+      
+      switch ($type)
+      {
+        case 'image':
+          $element = get_picture_infos($element_id, false);
+          break;
+        case 'album-images':
+        case 'album':
+          $element = get_category_infos($element_id, false);
+          break;
+        default:
+          $element = null;
+      }
+      
+      $template->assign(array(
+        'type' => $type,
+        'element' => $element,
+        ));
+    }
+    
+    $template->assign('IN_VALIDATE', true);
+    break;
+  }
+  
+  /* unsubscribe */
+  case 'unsubscribe':
+  {
+    $query = '
+SELECT
+    type,
+    element_id
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE 
+    email = "'.$_GET['email'].'"
+    AND id = '.$_GET['id'].'
+;';
+    $result = pwg_query($query);
+    
+    if (!pwg_db_num_rows($result))
+    {
+      array_push($page['errors'], l10n('Not found.'));
+    }
+    else
+    {
+      if (un_subscribe_to_comments($_GET['email'], $_GET['id']))
+      {
+        array_push($page['infos'], l10n('Successfully unsubscribed your email address from receiving notifications.'));
+      }
+      else
+      {
+        array_push($page['errors'], l10n('Not found.'));
+      }
+      
+      list($type, $element_id) = pwg_db_fetch_row($result);
+      
+      switch ($type)
+      {
+        case 'image':
+          $element = get_picture_infos($element_id);
+          break;
+        case 'album-images':
+        case 'album':
+          $element = get_category_infos($element_id);
+          break;
+        default:
+          $element = null;
+      }
+      
+      $template->assign(array(
+        'type' => $type,
+        'element' => $element,
+        ));
+    }
+    
+    $template->assign('IN_UNSUBSCRIBE', true);
+    break;
+  }
+  
+  /* manage */
+  case 'manage':
+  {
+    $query = '
+SELECT *
+  FROM '.SUBSCRIBE_TO_TABLE.'
+  WHERE email = "'.$_GET['email'].'"
   ORDER BY registration_date DESC
 ;';
     $result = pwg_query($query);
     
-    if (pwg_db_num_rows($result) !== 0)
+    if (pwg_db_num_rows($result))
     {
       while ($subscription = pwg_db_fetch_assoc($result))
       {
-        if (!empty($subscription['image_id']))
+        $subscription['registration_date'] = format_date($subscription['registration_date'], true);
+        
+        switch ($subscription['type'])
         {
-          $subscription['infos'] = get_picture_infos($subscription['image_id']);
-          $subscription['type'] = 'image';
+          case 'image':
+            $subscription['infos'] = get_picture_infos($subscription['element_id']);
+            break;
+          case 'album-images':
+          case 'album':
+            $subscription['infos'] = get_category_infos($subscription['element_id']);
+            break;
+          default:
+            $subscription['infos'] = null;
+            $template->append('global_subscriptions', $subscription);
+            continue(2);
         }
-        else if (!empty($subscription['category_id']))
-        {
-          $subscription['infos'] = get_category_infos($subscription['category_id']);
-          $subscription['type'] = 'category';
-        }
-        $subscription['registration_date'] = format_date($subscription['registration_date'], true);
+        
         $template->append('subscriptions', $subscription);
       }
@@ -158,14 +220,19 @@
     else
     {
-      $template->assign('subscriptions', 'none');
+      array_push($page['infos'], l10n('You are not subscribed to any comment.'));
     }
     break;
   }
   
-  case 'hacker' :
+  default:
   {
     set_status_header(403);
-    array_push($errors, l10n('Bad query'));
-  }
+    array_push($page['errors'], l10n('Bad query'));
+  }
+}
+
+if (isset($pwg_loaded_plugins['Comments_on_Albums']))
+{
+  $template->assign('COA_ACTIVATED', true);
 }
 
@@ -175,9 +242,5 @@
   ));
 
-$template->assign(array(
-  'infos' => $infos,
-  'errors' => $errors,
-  ));
-
 $template->set_filenames(array('index'=> dirname(__FILE__).'/../template/subscribtions_page.tpl'));
+
 ?>
Index: extensions/Subscribe_to_comments/index.php
===================================================================
--- extensions/Subscribe_to_comments/index.php	(revision 15376)
+++ extensions/Subscribe_to_comments/index.php	(revision 15641)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based photo gallery                                    |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2011 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
